VERSION 5.00
Begin VB.Form frmTempMkr 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "FrontPage Web Template Maker"
   ClientHeight    =   4200
   ClientLeft      =   1845
   ClientTop       =   3000
   ClientWidth     =   6180
   Icon            =   "tempmkr.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4200
   ScaleWidth      =   6180
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton btnRefresh 
      Caption         =   "&Refresh Web List"
      Height          =   375
      Left            =   120
      TabIndex        =   7
      Top             =   3720
      Width           =   1815
   End
   Begin VB.Frame grpTemplate 
      Caption         =   "New Web Template"
      Height          =   3135
      Left            =   2640
      TabIndex        =   11
      Top             =   480
      Width           =   3375
      Begin VB.TextBox txtTitle 
         Height          =   315
         Left            =   180
         TabIndex        =   2
         Top             =   540
         Width           =   3015
      End
      Begin VB.TextBox txtName 
         Height          =   315
         Left            =   180
         TabIndex        =   4
         Top             =   1200
         Width           =   3015
      End
      Begin VB.TextBox txtDescription 
         Height          =   1095
         Left            =   180
         MultiLine       =   -1  'True
         ScrollBars      =   2  'Vertical
         TabIndex        =   6
         Top             =   1860
         Width           =   3015
      End
      Begin VB.Label lblTitle 
         Caption         =   "&Title:"
         Height          =   195
         Left            =   180
         TabIndex        =   1
         Top             =   300
         Width           =   2415
      End
      Begin VB.Label lblName 
         Caption         =   "N&ame:"
         Height          =   195
         Left            =   180
         TabIndex        =   3
         Top             =   960
         Width           =   2415
      End
      Begin VB.Label lblDescription 
         Caption         =   "&Description:"
         Height          =   195
         Left            =   180
         TabIndex        =   5
         Top             =   1620
         Width           =   2415
      End
   End
   Begin VB.Frame grpWebs 
      Caption         =   "Available Webs"
      Height          =   3135
      Left            =   120
      TabIndex        =   10
      Top             =   480
      Width           =   2355
      Begin VB.ListBox lstWebs 
         Height          =   2205
         Left            =   180
         TabIndex        =   0
         Top             =   540
         Width           =   1995
      End
      Begin VB.Label Label4 
         Caption         =   "&Name:"
         Height          =   195
         Left            =   180
         TabIndex        =   12
         Top             =   300
         Width           =   1515
      End
   End
   Begin VB.CommandButton btnSave 
      Caption         =   "&Make Web Template"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4200
      TabIndex        =   9
      Top             =   3720
      Width           =   1815
   End
   Begin VB.CommandButton btnHelp 
      Caption         =   "Help..."
      Height          =   375
      Left            =   2640
      TabIndex        =   8
      Top             =   3720
      Width           =   915
   End
   Begin VB.Label lblStatus 
      Caption         =   "Status..."
      Height          =   255
      Left            =   120
      TabIndex        =   13
      Top             =   120
      Width           =   5895
   End
End
Attribute VB_Name = "frmTempMkr"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim FPRoot As String
Dim PWSRoot As String

Private Sub btnHelp_Click()
    frmHelp.Show 1
End Sub

Private Sub btnRefresh_Click()
    LoadWebList
End Sub

Private Sub btnSave_Click()
    
    Dim fpwebs As String
    Dim ext As String
    Dim WebPath As String
    Dim webname As String
    
    fpwebs = FPRoot & "\webs\"
    ext = ".tem"
    webname = txtName & ext
    WebPath = fpwebs & webname
    
    ' check for valid name
    If InStr(txtName, " ") > 0 Or InStr(txtName, ".") > 0 Then
        MsgBox "A web template name cannot contain spaces or dots.", vbExclamation, "Invalid Web Template Name"
        Exit Sub
    End If
                
    ' check if web dir already exists
    If Len(Dir(WebPath, vbDirectory)) > 0 Then
        MsgBox "A web template directory with the name '" & txtName & "' already exists." & Chr$(10) & "Choose another name, or delete the existing web template directory.", vbExclamation, "Duplicate Web Template Name"
        Exit Sub
    End If
    
    ' do it
    SaveWebTemplate
    
End Sub

Private Sub Form_Load()

    FPRoot = GetIniValue("frontpg.ini", "FrontPage 1.1", "FrontPageRoot")
    PWSRoot = GetIniValue("frontpg.ini", "FrontPage 1.1", "PWSRoot")
    
    LoadWebList
    
    CenterFormOnScreen Me

End Sub
Public Sub LoadWebList()

    Dim servlist As String
    Dim fn As Integer
    Dim webname As String

    servlist = PWSRoot & "\Content\_vti_pvt\services.cnf"
    
    On Error GoTo NoFile
    
    fn = FreeFile
    Open servlist For Input Access Read As #fn
    
    lstWebs.Clear
    
    While Not EOF(fn)
        Line Input #fn, webname
        ' strip initial slash
        If Left$(webname, 1) = "/" Then webname = Mid$(webname, 2)
        If Len(webname) Then
            lstWebs.AddItem webname
        End If
    Wend
    
    Close #fn
    
    ' reset state of buttons and text boxes
    btnSave.Enabled = False
    txtName = ""
    txtName.Enabled = False
    lblName.Enabled = False
    txtTitle = ""
    txtTitle.Enabled = False
    lblTitle.Enabled = False
    txtDescription = ""
    txtDescription.Enabled = False
    lblDescription.Enabled = False
    
    lblStatus = "Select a web as the source for your template ..."
    
    Exit Sub
    
NoFile:
    MsgBox "Can't open web list: " & Chr$(13) & Chr$(10) & servlist
    Exit Sub
    
End Sub

Private Sub lstWebs_Click()
    
    Dim web As String
    web = lstWebs.List(lstWebs.ListIndex)
    
    ' reset state of controls
    btnSave.Enabled = True
    txtName = web
    txtName.Enabled = True
    lblName.Enabled = True
    txtTitle = web & " Web"
    txtTitle.Enabled = True
    lblTitle.Enabled = True
    txtDescription = "Create a " & web & " web."
    txtDescription.Enabled = True
    lblDescription.Enabled = True
    
    lblStatus = "Provide a title and description for your web template ..."
    
End Sub



Public Function MakeURLSlashes(path As String) As String

    Dim out As String
    Dim i As Integer
    Dim ch As String
    out = ""
    
    For i = 1 To Len(path)
        ch = Mid$(path, i, 1)
        If ch = "\" Then ch = "/"
        out = out & ch
    Next i
    
    MakeURLSlashes = out

End Function

Public Function MakeDirSlashes(path As String) As String

    Dim out As String
    Dim i As Integer
    Dim ch As String
    out = ""
    
    For i = 1 To Len(path)
        ch = Mid$(path, i, 1)
        If ch = "/" Then ch = "\"
        out = out & ch
    Next i
    
    MakeDirSlashes = out

End Function

Public Sub SaveWebTemplate()

    Dim WebRoot As String
    Dim TemplateRoot As String
    Dim inifile As String
    Dim web As String
    
    ' indicate to user that we're hard at work
    btnSave.Enabled = False
    MousePointer = 11
    DoEvents
    
    web = lstWebs.List(lstWebs.ListIndex)
    WebRoot = PWSRoot & "\Content\" & web
    
    TemplateRoot = FPRoot & "\webs\" & txtName & ".tem"
    inifile = TemplateRoot & "\" & txtName & ".inf"
    
    On Error GoTo FileSystemErr
    
    lblStatus = "Creating web template directory ..."
    lblStatus.Refresh
    
    ' create standard directories
    MkDir TemplateRoot
    MkDir TemplateRoot & "\images"
    MkDir TemplateRoot & "\cgi-bin"
    MkDir TemplateRoot & "\_private"
    
    lblStatus = "Creating web template info file ..."
    lblStatus.Refresh
    
    ' create INF file
    SetIniValue inifile, "info", "title", txtTitle
    SetIniValue inifile, "info", "description", RemoveNewlines(txtDescription)
    
    ' copy standard dirs and their contents to new web template
    
    lblStatus = "Copying files from main web directory ..."
    lblStatus.Refresh
    CopyWebTemplateDir WebRoot, TemplateRoot, inifile, ""
    
    lblStatus = "Copying files from images web directory ..."
    lblStatus.Refresh
    CopyWebTemplateDir WebRoot, TemplateRoot, inifile, "images\"
    
    lblStatus = "Copying files in _private web directory ..."
    lblStatus.Refresh
    CopyWebTemplateDir WebRoot, TemplateRoot, inifile, "_private\"
    
    lblStatus = "Copying files in cgi-bin web directory ..."
    lblStatus.Refresh
    CopyWebTemplateDir WebRoot, TemplateRoot, inifile, "cgi-bin\"
        
    ' copy web meta-info vars
    lblStatus = "Copying web meta-info ..."
    lblStatus.Refresh
    CopyWebMetaInfo WebRoot, TemplateRoot, inifile
    
    ' copy to-do-list tasks
    lblStatus = "Copying To Do List tasks ..."
    lblStatus.Refresh
    CopyToDoListTasks WebRoot, TemplateRoot, inifile, txtTitle
        
    ' remove hourglass
    MousePointer = 0
    
    ' go back to initial state
    LoadWebList
    
    Exit Sub
    
FileSystemErr:
    MsgBox Err.Description, vbCritical, "Error Copying Web Files"
    LoadWebList
    MousePointer = 0
    Exit Sub
    
End Sub

Public Function RemoveNewlines(str As String) As String

    Dim out As String
    Dim ch As String
    Dim i As Integer
    
    out = ""
    
    For i = 1 To Len(str)
        ch = Mid$(str, i, 1)
        If ch <> Chr$(13) And ch <> Chr$(10) Then
            out = out & ch
        End If
    Next i
    
    RemoveNewlines = out

End Function


Public Sub CopyWebTemplateDir(WebRoot As String, TemplateRoot As String, inifile As String, dirname As String)

    Dim dirpath As String
    Dim dirurl As String
    Dim tmplpath As String
    Dim shmpath As String
    Dim file As String

    dirpath = WebRoot & "\" & dirname
    tmplpath = TemplateRoot & "\" & dirname
    dirurl = MakeURLSlashes(dirname)
    shmpath = "_vti_shm\"
    
    file = Dir(dirpath & "*.*", vbNormal)
    While Len(file)
        ' don't copy access control files
        If Right$(LCase$(file), 4) <> ".ctl" Then
            ' copy the SmartHTML file from _vti_shm if it exists,
            ' otherwise copy the expanded version
            If FileExists(dirpath & shmpath & file) Then
                FileCopy dirpath & shmpath & file, tmplpath & file
            Else
                FileCopy dirpath & file, tmplpath & file
            End If
            ' make an entry in the FileList section
            SetIniValue inifile, "FileList", dirname & file, dirurl & file
        End If
        file = Dir()
    Wend

End Sub

Public Sub CopyWebMetaInfo(WebRoot As String, TemplateRoot As String, inifile As String)

    Dim metafile As String
    Dim fn As Integer
    Dim var As String
    Dim key As String
    Dim value As String
    Dim idx As Integer
    
    metafile = WebRoot & "\_vti_pvt\service.cnf"
    
    If Not FileExists(metafile) Then Exit Sub
    
    fn = FreeFile
    Open metafile For Input Access Read As #fn
    Do While Not EOF(fn)
        Line Input #fn, var
        ' ignore the built-in variables
        If Left$(var, 4) <> "vti_" Then
            idx = InStr(var, ":")
            If idx > 0 Then
                key = Left$(var, idx - 1)
                idx = InStr(idx + 1, var, "|")
                If idx > 0 Then
                    value = Mid$(var, idx + 1)
                    SetIniValue inifile, "MetaInfo", key, value
                End If
            End If
        End If
    Loop
    Close #fn

End Sub

Public Sub CopyToDoListTasks(WebRoot As String, TemplateRoot As String, inifile As String, title As String)
    
    Dim tdlfile As String
    Dim fn As Integer
    Dim str As String
    Dim idx As Integer
    Dim endidx As Integer
    Dim i As Integer
    Dim tdl As String
    Dim taskname As String
    Dim priority As String
    Dim URL As String
    Dim cookie As String
    Dim comment As String
    Dim tasknum As Integer
    Dim key As String
    Dim value As String
    
    Const Version = "<META VERSION=""1"">"
    Const BeginRecord = "<TR>"
    Const EndRecord = "</TR>"
    Const BeginField = "<TD>"
    Const EndField = "</TD>"
    Const sep = "|"
    
    tdlfile = WebRoot & "\_vti_pvt\_x_todo.htm"
    
    If Not FileExists(tdlfile) Then Exit Sub
    
    ' have to parse To Do List file
    
    tdl = StringFromFile(tdlfile)
    If Len(tdl) = 0 Then Exit Sub
    
    ' verify that version is 1
    If InStr(tdl, Version) = 0 Then Exit Sub
            
    ' scan down to end of first record (just has field headings)
    idx = InStr(idx + 1, tdl, EndRecord)
    If idx = 0 Then Exit Sub
    
    ' go through following loop once for each task;
    ' extra info from task record bracketed by <TR> and </TR>
    idx = InStr(idx + 1, tdl, BeginRecord)
    
    tasknum = 0
    
    Do While idx > 0
        
        ' reset all task fields
        taskname = ""
        priority = ""
        URL = ""
        cookie = ""
        comment = ""
                
        ' field 2 is taskname, 3 is priority,
        ' 11 is URL, 12 is cookie, 13 is comment
        
        ' skip field 1
        idx = InStr(idx + 1, tdl, BeginField)
        
        ' get field 2: taskname
        idx = InStr(idx + 1, tdl, BeginField)
        endidx = InStr(idx + 1, tdl, EndField)
        If endidx > idx Then
            idx = idx + Len(BeginField)
            taskname = Trim$(Mid$(tdl, idx, endidx - idx))
        End If
        
        ' get field 3: priority
        idx = InStr(idx + 1, tdl, BeginField)
        endidx = InStr(idx + 1, tdl, EndField)
        If endidx > idx Then
            idx = idx + Len(BeginField)
            priority = Trim$(Mid$(tdl, idx, endidx - idx))
        End If
        
        ' skip fields 4 through 10
        For i = 1 To 7
            idx = InStr(idx + 1, tdl, BeginField)
        Next i
        ' get field 11: URL
        idx = InStr(idx + 1, tdl, BeginField)
        endidx = InStr(idx + 1, tdl, EndField)
        If endidx > idx Then
            idx = idx + Len(BeginField)
            URL = Trim$(Mid$(tdl, idx, endidx - idx))
        End If
        
        ' get field 12: cookie
        idx = InStr(idx + 1, tdl, BeginField)
        endidx = InStr(idx + 1, tdl, EndField)
        If endidx > idx Then
            idx = idx + Len(BeginField)
            cookie = Trim$(Mid$(tdl, idx, endidx - idx))
        End If
        
        ' get field 13: comment
        idx = InStr(idx + 1, tdl, BeginField)
        endidx = InStr(idx + 1, tdl, EndField)
        If endidx > idx Then
            idx = idx + Len(BeginField)
            comment = Trim$(Mid$(tdl, idx, endidx - idx))
        End If
        
        ' we have everything we need; construct task;
        ' instead of preserving CreatedByTool, set it to
        ' the title of the web template as passed in
        tasknum = tasknum + 1
        key = "task" & tasknum
        value = taskname & sep & priority & sep & title & sep & URL & sep & cookie & sep & comment
        SetIniValue inifile, "TaskList", key, RemoveNewlines(value)
          
        ' scan for next record
        idx = InStr(idx + 1, tdl, BeginRecord)
        
    Loop
    
End Sub


