VERSION 5.00
Begin VB.Form frmAPITests 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "FrontPage API Tests"
   ClientHeight    =   4455
   ClientLeft      =   1125
   ClientTop       =   1530
   ClientWidth     =   6735
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4455
   ScaleWidth      =   6735
   ShowInTaskbar   =   0   'False
   Begin VB.Frame Frame3 
      Caption         =   "FrontPage To Do List"
      Height          =   855
      Left            =   120
      TabIndex        =   11
      Top             =   3420
      Width           =   6495
      Begin VB.CommandButton btnCompleteTask 
         Caption         =   "Complete Task"
         Height          =   375
         Left            =   4860
         TabIndex        =   19
         Top             =   300
         Width           =   1455
      End
      Begin VB.CommandButton btnAddTask 
         Caption         =   "Add Task"
         Height          =   375
         Left            =   3300
         TabIndex        =   18
         Top             =   300
         Width           =   1455
      End
      Begin VB.CommandButton btnTaskCount 
         Caption         =   "Get Task Count"
         Height          =   375
         Left            =   1740
         TabIndex        =   17
         Top             =   300
         Width           =   1455
      End
      Begin VB.CommandButton btnShow 
         Caption         =   "Show/Hide"
         Height          =   375
         Left            =   180
         TabIndex        =   16
         Top             =   300
         Width           =   1455
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "FrontPage Editor"
      Height          =   915
      Left            =   120
      TabIndex        =   10
      Top             =   2340
      Width           =   6495
      Begin VB.CommandButton btnNewPage 
         Caption         =   "New Web Page"
         Height          =   375
         Left            =   4860
         TabIndex        =   15
         Top             =   360
         Width           =   1455
      End
      Begin VB.CommandButton btnTop 
         Caption         =   "Bring to Top"
         Height          =   375
         Left            =   3300
         TabIndex        =   14
         Top             =   360
         Width           =   1455
      End
      Begin VB.CommandButton btnQueryPage 
         Caption         =   "Query Web Page"
         Height          =   375
         Left            =   1740
         TabIndex        =   13
         Top             =   360
         Width           =   1455
      End
      Begin VB.CommandButton btnOpenPage 
         Caption         =   "Open Web Page"
         Height          =   375
         Left            =   180
         TabIndex        =   12
         Top             =   360
         Width           =   1455
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "FrontPage Explorer"
      Height          =   1395
      Left            =   120
      TabIndex        =   1
      Top             =   780
      Width           =   6495
      Begin VB.CommandButton btnListDocs 
         Caption         =   "List Documents"
         Height          =   375
         Left            =   1740
         TabIndex        =   9
         Top             =   360
         Width           =   1455
      End
      Begin VB.CommandButton btnPageInfo 
         Caption         =   "Page Information"
         Height          =   375
         Left            =   1740
         TabIndex        =   8
         Top             =   840
         Width           =   1455
      End
      Begin VB.CommandButton btnSaveDoc 
         Caption         =   "Get Document"
         Height          =   375
         Left            =   3300
         TabIndex        =   7
         Top             =   840
         Width           =   1455
      End
      Begin VB.CommandButton btnWebInfo 
         Caption         =   "Web Information"
         Height          =   375
         Left            =   180
         TabIndex        =   6
         Top             =   360
         Width           =   1455
      End
      Begin VB.CommandButton btnOpenWeb 
         Caption         =   "Open Web"
         Height          =   375
         Left            =   3300
         TabIndex        =   5
         Top             =   360
         Width           =   1455
      End
      Begin VB.CommandButton btnMisc 
         Caption         =   "Miscellaneous"
         Height          =   375
         Left            =   4860
         TabIndex        =   4
         Top             =   840
         Width           =   1455
      End
      Begin VB.CommandButton btnCreate 
         Caption         =   "Create/Remove"
         Height          =   375
         Left            =   180
         TabIndex        =   3
         Top             =   840
         Width           =   1455
      End
      Begin VB.CommandButton btnPutDocs 
         Caption         =   "Put Documents"
         Height          =   375
         Left            =   4860
         TabIndex        =   2
         Top             =   360
         Width           =   1455
      End
   End
   Begin VB.Label Label1 
      Caption         =   $"apitests.frx":0000
      Height          =   615
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   6495
   End
End
Attribute VB_Name = "frmAPITests"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub btnAddTask_Click()
    frmAddTask.Show 1
End Sub


Private Sub btnCompleteTask_Click()
    frmCompleteTask.Show 1
End Sub

Private Sub btnCreate_Click()
    frmCreate.Show 1
End Sub


Private Sub btnListDocs_Click()
    MousePointer = 11
    frmListDocs.Show 1
    MousePointer = 0
End Sub


Private Sub btnMisc_Click()
    frmMisc.Show 1
End Sub

Private Sub btnNewPage_Click()

    Dim editor As Object
    Dim page As Object
    
    Set editor = CreateObject("FrontPage.Editor")
    Set page = editor.vtiNewWebPage("test.htm", "", "")
    Set editor = Nothing
    
End Sub

Private Sub btnOpenPage_Click()
    frmOpenPage.Show 1
End Sub

Private Sub btnOpenWeb_Click()
    frmOpenWeb.Show 1
End Sub

Private Sub btnPageInfo_Click()
    MousePointer = 11
    frmPageInfo.Show 1
    MousePointer = 0
End Sub


Private Sub btnPutDocs_Click()
    frmPutDocs.Show 1
End Sub

Private Sub btnQueryPage_Click()
    frmQueryPage.Show 1
End Sub

Private Sub btnSaveDoc_Click()
    frmSaveDoc.Show 1
End Sub

Private Sub btnShow_Click()
    frmTDLshow.Show 1
End Sub

Private Sub btnTaskCount_Click()

    Dim todolist As Object
    Dim ret As Long
    
    Set todolist = CreateObject("FrontPage.ToDoList")
    ret = todolist.vtiGetActiveCount()
    Set todolist = Nothing
    
    MsgBox "There are " & ret & " active tasks in the To Do List."
    
End Sub


Private Sub btnTop_Click()

    Dim editor As Object
    
    MousePointer = 11
    
    Set editor = CreateObject("FrontPage.Editor")
    editor.vtiBringToTop
    Set editor = Nothing
    
    MousePointer = 0
    
End Sub

Private Sub btnWebInfo_Click()
    MousePointer = 11
    frmWebInfo.Show 1
    MousePointer = 0
End Sub


Private Sub Label2_Click()

End Sub



