//
// Copyright (c) 1997 Microsoft Corp.  All Rights Reserved
//
// VoteBotDialog.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CVoteBotDialog dialog

#include "../webbot.h"

class CVoteBotDialog : public CDialog
{
// Construction
public:
	CVoteBotDialog(CWnd* pParent = NULL);   // standard constructor

	void DialogToDictionary(CWebBotDict &dict);
	
	void DictionaryToDialog(CWebBotDict &dict);
	// reads bot info from WebBotDict and maps to component editor dialog

// Dialog Data
	//{{AFX_DATA(CVoteBotDialog)
	enum { IDD = IDD_DIALOG1 };
	int	  m_votetype;
	int	  m_voteopt;
	bool    m_bModified;
	bool    m_bFirstEdit;

	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVoteBotDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

	
// Implementation
protected:

	afx_msg void setModFlag();

	// Generated message map functions
	//{{AFX_MSG(CVoteBotDialog)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
